Index: kernel/generic/src/mm/backend_elf.c
===================================================================
--- kernel/generic/src/mm/backend_elf.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/generic/src/mm/backend_elf.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -232,9 +232,14 @@
 void elf_frame_free(as_area_t *area, uintptr_t page, uintptr_t frame)
 {
+	elf_header_t *elf = area->backend_data.elf;
 	elf_segment_header_t *entry = area->backend_data.segment;
-	uintptr_t start_anon;
+	uintptr_t base, start_anon;
+	size_t i;
 
 	ASSERT((page >= ALIGN_DOWN(entry->p_vaddr, PAGE_SIZE)) &&
 	    (page < entry->p_vaddr + entry->p_memsz));
+	i = (page - ALIGN_DOWN(entry->p_vaddr, PAGE_SIZE)) >> PAGE_WIDTH;
+	base = (uintptr_t) (((void *) elf) +
+	    ALIGN_DOWN(entry->p_offset, FRAME_SIZE));
 	start_anon = entry->p_vaddr + entry->p_filesz;
 
@@ -252,5 +257,5 @@
 		 * lower part is backed by the ELF image and the upper is
 		 * anonymous). In any case, a frame needs to be freed.
-		 */
+		 */ 
 		frame_free(frame);
 	}
Index: kernel/generic/src/mm/slab.c
===================================================================
--- kernel/generic/src/mm/slab.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/generic/src/mm/slab.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -130,5 +130,5 @@
 /** Caches for malloc */
 static slab_cache_t *malloc_caches[SLAB_MAX_MALLOC_W - SLAB_MIN_MALLOC_W + 1];
-static const char *malloc_names[] =  {
+static char *malloc_names[] =  {
 	"malloc-16",
 	"malloc-32",
@@ -571,7 +571,8 @@
 
 /** Initialize allocated memory as a slab cache */
-static void _slab_cache_create(slab_cache_t *cache, const char *name,
-    size_t size, size_t align, int (*constructor)(void *obj, int kmflag),
-    int (*destructor)(void *obj), int flags)
+static void
+_slab_cache_create(slab_cache_t *cache, char *name, size_t size, size_t align,
+    int (*constructor)(void *obj, int kmflag), int (*destructor)(void *obj),
+    int flags)
 {
 	int pages;
@@ -630,5 +631,6 @@
 
 /** Create slab cache  */
-slab_cache_t *slab_cache_create(const char *name, size_t size, size_t align,
+slab_cache_t *
+slab_cache_create(char *name, size_t size, size_t align,
     int (*constructor)(void *obj, int kmflag), int (*destructor)(void *obj),
     int flags)
@@ -851,5 +853,5 @@
 		cache = list_get_instance(cur, slab_cache_t, link);
 
-		const char *name = cache->name;
+		char *name = cache->name;
 		uint8_t order = cache->order;
 		size_t size = cache->size;
@@ -894,5 +896,5 @@
 		    NULL, NULL, SLAB_CACHE_MAGDEFERRED);
 	}
-#ifdef CONFIG_DEBUG
+#ifdef CONFIG_DEBUG       
 	_slab_initialized = 1;
 #endif
Index: kernel/generic/src/proc/scheduler.c
===================================================================
--- kernel/generic/src/proc/scheduler.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/generic/src/proc/scheduler.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -542,9 +542,6 @@
 {
 	thread_t *t;
-	int count;
-	atomic_count_t average;
+	int count, average, j, k = 0;
 	unsigned int i;
-	int j;
-	int k = 0;
 	ipl_t ipl;
 
Index: kernel/generic/src/proc/task.c
===================================================================
--- kernel/generic/src/proc/task.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/generic/src/proc/task.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -171,5 +171,5 @@
  *
  */
-task_t *task_create(as_t *as, const char *name)
+task_t *task_create(as_t *as, char *name)
 {
 	ipl_t ipl;
Index: kernel/generic/src/proc/thread.c
===================================================================
--- kernel/generic/src/proc/thread.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/generic/src/proc/thread.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -76,5 +76,5 @@
 
 /** Thread states */
-const char *thread_states[] = {
+char *thread_states[] = {
 	"Invalid",
 	"Running",
@@ -264,5 +264,4 @@
 
 	atomic_inc(&nrdy);
-	// FIXME: Why is the avg value never read?
 	avg = atomic_get(&nrdy) / config.cpu_active;
 	atomic_inc(&cpu->nrdy);
@@ -289,5 +288,5 @@
  */
 thread_t *thread_create(void (* func)(void *), void *arg, task_t *task,
-    int flags, const char *name, bool uncounted)
+    int flags, char *name, bool uncounted)
 {
 	thread_t *t;
Index: kernel/generic/src/synch/spinlock.c
===================================================================
--- kernel/generic/src/synch/spinlock.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/generic/src/synch/spinlock.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -52,5 +52,5 @@
  *
  */
-void spinlock_initialize(spinlock_t *lock, const char *name)
+void spinlock_initialize(spinlock_t *lock, char *name)
 {
 	atomic_set(&lock->val, 0);
Index: kernel/generic/src/sysinfo/sysinfo.c
===================================================================
--- kernel/generic/src/sysinfo/sysinfo.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/generic/src/sysinfo/sysinfo.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -46,5 +46,5 @@
 		return NULL;
 	
-	while (subtree != NULL) {
+	while (subtree != NULL)	{
 		int i = 0;
 		char *a = (char *) name;
@@ -68,4 +68,5 @@
 		/* No matches try next */
 		subtree = subtree->next;
+		i = 0;
 	}
 	return NULL;
@@ -158,6 +159,8 @@
 			item->subinfo_type = SYSINFO_SUBINFO_NONE;
 			return item;
-		} else
+		} else {
 			subtree = subtree->next;
+			i = 0;
+		}	
 	}
 
@@ -222,5 +225,5 @@
 		int i;
 		unative_t val = 0;
-		const char *vtype = NULL;
+		char *vtype = NULL;
 		
 		
Index: kernel/generic/src/udebug/udebug_ops.c
===================================================================
--- kernel/generic/src/udebug/udebug_ops.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/generic/src/udebug/udebug_ops.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -80,5 +80,8 @@
 static int _thread_op_begin(thread_t *t, bool being_go)
 {
+	task_id_t taskid;
 	ipl_t ipl;
+
+	taskid = TASK->taskid;
 
 	mutex_lock(&TASK->udebug.lock);
Index: kernel/test/atomic/atomic1.c
===================================================================
--- kernel/test/atomic/atomic1.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/test/atomic/atomic1.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -32,5 +32,5 @@
 #include <debug.h>
 
-const char *test_atomic1(void)
+char *test_atomic1(void)
 {
 	atomic_t a;
Index: kernel/test/avltree/avltree1.c
===================================================================
--- kernel/test/avltree/avltree1.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/test/avltree/avltree1.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -265,5 +265,5 @@
 }
 
-const char *test_avltree1(void)
+char *test_avltree1(void)
 {
 	alloc_avltree_node_prepare();
Index: kernel/test/btree/btree1.c
===================================================================
--- kernel/test/btree/btree1.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/test/btree/btree1.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -34,5 +34,5 @@
 static void *data = (void *) 0xdeadbeef;
 
-const char *test_btree1(void)
+char *test_btree1(void)
 {
 	btree_t t;
Index: kernel/test/debug/mips1.c
===================================================================
--- kernel/test/debug/mips1.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/test/debug/mips1.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -37,5 +37,5 @@
 #include <arch.h>
 
-const char *test_mips1(void)
+char *test_mips1(void)
 {
 	TPRINTF("If kconsole is compiled in, you should enter debug mode now.\n");
Index: kernel/test/debug/mips1_skip.c
===================================================================
--- kernel/test/debug/mips1_skip.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/test/debug/mips1_skip.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -29,5 +29,5 @@
 #include <test.h>
 
-const char *test_mips1(void)
+char *test_mips1(void)
 {
 	return NULL;
Index: kernel/test/fault/fault1.c
===================================================================
--- kernel/test/fault/fault1.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/test/fault/fault1.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -37,5 +37,5 @@
 #include <arch.h>
 
-const char *test_fault1(void)
+char *test_fault1(void)
 {
 	((int *)(0))[1] = 0;
Index: kernel/test/fpu/fpu1_ia64.c
===================================================================
--- kernel/test/fpu/fpu1_ia64.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/test/fpu/fpu1_ia64.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -126,8 +126,7 @@
 }
 
-const char *test_fpu1(void)
+char *test_fpu1(void)
 {
-	unsigned int i;
-	atomic_count_t total = 0;
+	unsigned int i, total = 0;
 	
 	waitq_initialize(&can_start);
@@ -160,5 +159,5 @@
 	waitq_wakeup(&can_start, WAKEUP_ALL);
 	
-	while (atomic_get(&threads_ok) != total) {
+	while (atomic_get(&threads_ok) != (long) total) {
 		TPRINTF("Threads left: %d\n", total - atomic_get(&threads_ok));
 		thread_sleep(1);
Index: kernel/test/fpu/fpu1_skip.c
===================================================================
--- kernel/test/fpu/fpu1_skip.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/test/fpu/fpu1_skip.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -29,5 +29,5 @@
 #include <test.h>
 
-const char *test_fpu1(void)
+char *test_fpu1(void)
 {
 	return NULL;
Index: kernel/test/fpu/fpu1_x86.c
===================================================================
--- kernel/test/fpu/fpu1_x86.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/test/fpu/fpu1_x86.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -123,8 +123,7 @@
 }
 
-const char *test_fpu1(void)
+char *test_fpu1(void)
 {
-	unsigned int i;
-	atomic_count_t total = 0;
+	unsigned int i, total = 0;
 	
 	waitq_initialize(&can_start);
@@ -157,5 +156,5 @@
 	waitq_wakeup(&can_start, WAKEUP_ALL);
 	
-	while (atomic_get(&threads_ok) != total) {
+	while (atomic_get(&threads_ok) != (long) total) {
 		TPRINTF("Threads left: %d\n", total - atomic_get(&threads_ok));
 		thread_sleep(1);
Index: kernel/test/fpu/mips2.c
===================================================================
--- kernel/test/fpu/mips2.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/test/fpu/mips2.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -109,8 +109,7 @@
 
 
-const char *test_mips2(void)
+char *test_mips2(void)
 {
-	unsigned int i;
-	atomic_count_t total = 0;
+	unsigned int i, total = 0;
 	
 	waitq_initialize(&can_start);
@@ -139,9 +138,9 @@
 	
 	TPRINTF("ok\n");
-	
+		
 	thread_sleep(1);
 	waitq_wakeup(&can_start, WAKEUP_ALL);
 	
-	while (atomic_get(&threads_ok) != total) {
+	while (atomic_get(&threads_ok) != (long) total) {
 		TPRINTF("Threads left: %d\n", total - atomic_get(&threads_ok));
 		thread_sleep(1);
Index: kernel/test/fpu/mips2_skip.c
===================================================================
--- kernel/test/fpu/mips2_skip.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/test/fpu/mips2_skip.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -29,5 +29,5 @@
 #include <test.h>
 
-const char *test_mips2(void)
+char *test_mips2(void)
 {
 	return NULL;
Index: kernel/test/fpu/sse1.c
===================================================================
--- kernel/test/fpu/sse1.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/test/fpu/sse1.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -107,8 +107,7 @@
 }
 
-const char *test_sse1(void)
+char *test_sse1(void)
 {
-	unsigned int i;
-	atomic_count_t total = 0;
+	unsigned int i, total = 0;
 	
 	waitq_initialize(&can_start);
@@ -141,5 +140,5 @@
 	waitq_wakeup(&can_start, WAKEUP_ALL);
 	
-	while (atomic_get(&threads_ok) != total) {
+	while (atomic_get(&threads_ok) != (long) total) {
 		TPRINTF("Threads left: %d\n", total - atomic_get(&threads_ok));
 		thread_sleep(1);
Index: kernel/test/fpu/sse1_skip.c
===================================================================
--- kernel/test/fpu/sse1_skip.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/test/fpu/sse1_skip.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -29,5 +29,5 @@
 #include <test.h>
 
-const char *test_sse1(void)
+char *test_sse1(void)
 {
 	return NULL;
Index: kernel/test/mm/falloc1.c
===================================================================
--- kernel/test/mm/falloc1.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/test/mm/falloc1.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -41,5 +41,5 @@
 #define TEST_RUNS   2
 
-const char *test_falloc1(void) {
+char *test_falloc1(void) {
 	uintptr_t *frames
 	    = (uintptr_t *) malloc(MAX_FRAMES * sizeof(uintptr_t), 0);
Index: kernel/test/mm/falloc2.c
===================================================================
--- kernel/test/mm/falloc2.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/test/mm/falloc2.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -104,5 +104,5 @@
 }
 
-const char *test_falloc2(void)
+char *test_falloc2(void)
 {
 	unsigned int i;
Index: kernel/test/mm/mapping1.c
===================================================================
--- kernel/test/mm/mapping1.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/test/mm/mapping1.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -42,5 +42,5 @@
 #define VALUE1  0x89abcdef
 
-const char *test_mapping1(void)
+char *test_mapping1(void)
 {
 	uintptr_t frame0, frame1;
Index: kernel/test/mm/purge1.c
===================================================================
--- kernel/test/mm/purge1.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/test/mm/purge1.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -40,5 +40,5 @@
 extern void tlb_invalidate_pages(asid_t asid, uintptr_t va, size_t cnt);
 
-const char *test_purge1(void)
+char *test_purge1(void)
 {
 	tlb_entry_t entryi;
Index: kernel/test/mm/purge1_skip.c
===================================================================
--- kernel/test/mm/purge1_skip.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/test/mm/purge1_skip.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -29,5 +29,5 @@
 #include <test.h>
 
-const char *test_purge1(void)
+char *test_purge1(void)
 {
 	return NULL;
Index: kernel/test/mm/slab1.c
===================================================================
--- kernel/test/mm/slab1.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/test/mm/slab1.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -170,5 +170,5 @@
 }
 
-const char *test_slab1(void)
+char *test_slab1(void)
 {
 	testsimple();
Index: kernel/test/mm/slab2.c
===================================================================
--- kernel/test/mm/slab2.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/test/mm/slab2.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -226,5 +226,5 @@
 }
 
-const char *test_slab2(void)
+char *test_slab2(void)
 {
 	TPRINTF("Running reclaim single-thread test .. pass 1\n");
Index: kernel/test/print/print1.c
===================================================================
--- kernel/test/print/print1.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/test/print/print1.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -30,5 +30,5 @@
 #include <test.h>
 
-const char *test_print1(void)
+char *test_print1(void)
 {
 	TPRINTF("Testing printf(\"%%*.*s\", 5, 3, \"text\"):\n");
Index: kernel/test/print/print2.c
===================================================================
--- kernel/test/print/print2.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/test/print/print2.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -30,5 +30,5 @@
 #include <test.h>
 
-const char *test_print2(void)
+char *test_print2(void)
 {
 	TPRINTF("Testing printf(\"%%c %%3.2c %%-3.2c %%2.3c %%-2.3c\", 'a', 'b', 'c', 'd', 'e'):\n");
Index: kernel/test/print/print3.c
===================================================================
--- kernel/test/print/print3.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/test/print/print3.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -33,5 +33,5 @@
 #define BUFFER_SIZE  32
 
-const char *test_print3(void)
+char *test_print3(void)
 {
 	char buffer[BUFFER_SIZE];
Index: kernel/test/print/print4.c
===================================================================
--- kernel/test/print/print4.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/test/print/print4.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -30,5 +30,5 @@
 #include <test.h>
 
-const char *test_print4(void)
+char *test_print4(void)
 {
 	TPRINTF("ASCII printable characters (32 - 127) using printf(\"%%c\") and printf(\"%%lc\"):\n");
Index: kernel/test/synch/rwlock1.c
===================================================================
--- kernel/test/synch/rwlock1.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/test/synch/rwlock1.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -41,5 +41,5 @@
 static rwlock_t rwlock;
 
-const char *test_rwlock1(void)
+char *test_rwlock1(void)
 {
 	rwlock_initialize(&rwlock);
Index: kernel/test/synch/rwlock2.c
===================================================================
--- kernel/test/synch/rwlock2.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/test/synch/rwlock2.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -53,5 +53,5 @@
 }
 
-const char *test_rwlock2(void)
+char *test_rwlock2(void)
 {
 	thread_t *thrd;
Index: kernel/test/synch/rwlock3.c
===================================================================
--- kernel/test/synch/rwlock3.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/test/synch/rwlock3.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -60,5 +60,5 @@
 }
 
-const char *test_rwlock3(void)
+char *test_rwlock3(void)
 {
 	int i;
Index: kernel/test/synch/rwlock4.c
===================================================================
--- kernel/test/synch/rwlock4.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/test/synch/rwlock4.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -132,5 +132,5 @@
 }
 
-const char *test_rwlock4(void)
+char *test_rwlock4(void)
 {
 	context_t ctx;
Index: kernel/test/synch/rwlock5.c
===================================================================
--- kernel/test/synch/rwlock5.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/test/synch/rwlock5.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -67,9 +67,8 @@
 }
 
-const char *test_rwlock5(void)
+char *test_rwlock5(void)
 {
 	int i, j, k;
-	atomic_count_t readers;
-	atomic_count_t writers;
+	long readers, writers;
 	
 	waitq_initialize(&can_start);
Index: kernel/test/synch/semaphore1.c
===================================================================
--- kernel/test/synch/semaphore1.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/test/synch/semaphore1.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -70,9 +70,8 @@
 }
 
-const char *test_semaphore1(void)
+char *test_semaphore1(void)
 {
 	int i, j, k;
-	atomic_count_t consumers;
-	atomic_count_t producers;
+	int consumers, producers;
 	
 	waitq_initialize(&can_start);
Index: kernel/test/synch/semaphore2.c
===================================================================
--- kernel/test/synch/semaphore2.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/test/synch/semaphore2.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -82,5 +82,5 @@
 }
 
-const char *test_semaphore2(void)
+char *test_semaphore2(void)
 {
 	uint32_t i, k;
Index: kernel/test/sysinfo/sysinfo1.c
===================================================================
--- kernel/test/sysinfo/sysinfo1.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/test/sysinfo/sysinfo1.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -33,5 +33,5 @@
 #include <sysinfo/sysinfo.h>
 
-const char *test_sysinfo1(void)
+char *test_sysinfo1(void)
 {
 	if (!test_quiet)
Index: kernel/test/test.h
===================================================================
--- kernel/test/test.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/test/test.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -48,40 +48,40 @@
 	}
 
-typedef const char *(*test_entry_t)(void);
+typedef char *(*test_entry_t)(void);
 
 typedef struct {
-	const char *name;
-	const char *desc;
+	char *name;
+	char *desc;
 	test_entry_t entry;
 	bool safe;
 } test_t;
 
-extern const char *test_atomic1(void);
-extern const char *test_avltree1(void);
-extern const char *test_btree1(void);
-extern const char *test_mips1(void);
-extern const char *test_fault1(void);
-extern const char *test_fpu1(void);
-extern const char *test_sse1(void);
-extern const char *test_mips2(void);
-extern const char *test_falloc1(void);
-extern const char *test_falloc2(void);
-extern const char *test_mapping1(void);
-extern const char *test_purge1(void);
-extern const char *test_slab1(void);
-extern const char *test_slab2(void);
-extern const char *test_rwlock1(void);
-extern const char *test_rwlock2(void);
-extern const char *test_rwlock3(void);
-extern const char *test_rwlock4(void);
-extern const char *test_rwlock5(void);
-extern const char *test_semaphore1(void);
-extern const char *test_semaphore2(void);
-extern const char *test_print1(void);
-extern const char *test_print2(void);
-extern const char *test_print3(void);
-extern const char *test_print4(void);
-extern const char *test_thread1(void);
-extern const char *test_sysinfo1(void);
+extern char *test_atomic1(void);
+extern char *test_avltree1(void);
+extern char *test_btree1(void);
+extern char *test_mips1(void);
+extern char *test_fault1(void);
+extern char *test_fpu1(void);
+extern char *test_sse1(void);
+extern char *test_mips2(void);
+extern char *test_falloc1(void);
+extern char *test_falloc2(void);
+extern char *test_mapping1(void);
+extern char *test_purge1(void);
+extern char *test_slab1(void);
+extern char *test_slab2(void);
+extern char *test_rwlock1(void);
+extern char *test_rwlock2(void);
+extern char *test_rwlock3(void);
+extern char *test_rwlock4(void);
+extern char *test_rwlock5(void);
+extern char *test_semaphore1(void);
+extern char *test_semaphore2(void);
+extern char *test_print1(void);
+extern char *test_print2(void);
+extern char *test_print3(void);
+extern char *test_print4(void);
+extern char *test_thread1(void);
+extern char *test_sysinfo1(void);
 
 extern test_t tests[];
Index: kernel/test/thread/thread1.c
===================================================================
--- kernel/test/thread/thread1.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/test/thread/thread1.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -53,13 +53,12 @@
 }
 
-const char *test_thread1(void)
+char *test_thread1(void)
 {
-	unsigned int i;
-	atomic_count_t total = 0;
+	unsigned int i, total = 0;
 	
 	atomic_set(&finish, 1);
 	atomic_set(&threads_finished, 0);
 	
-	for (i = 0; i < THREADS; i++) {
+	for (i = 0; i < THREADS; i++) {  
 		thread_t *t;
 		if (!(t = thread_create(threadtest, NULL, TASK, 0, "threadtest", false))) {
@@ -75,5 +74,5 @@
 	
 	atomic_set(&finish, 0);
-	while (atomic_get(&threads_finished) < total) {
+	while (atomic_get(&threads_finished) < ((long) total)) {
 		TPRINTF("Threads left: %d\n", total - atomic_get(&threads_finished));
 		thread_sleep(1);
Index: tools/checkers/stanse.py
===================================================================
--- tools/checkers/stanse.py	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ tools/checkers/stanse.py	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -74,6 +74,4 @@
 		srcfname = arg[0]
 		tgtfname = arg[1]
-		tool = arg[2]
-		category = arg[3]
 		base = arg[4]
 		options = arg[5]
@@ -85,5 +83,5 @@
 		
 		# Only C files are interesting for us
-		if (tool != "cc"):
+		if (arg[2] != "cc"):
 			continue
 		
Index: tools/checkers/vcc.py
===================================================================
--- tools/checkers/vcc.py	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ tools/checkers/vcc.py	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -70,5 +70,5 @@
 		# Ignore preprocessor directives
 		if (line.startswith('#')):
-			continue
+			continue	
 		
 		tmpf.write("%s\n" % line)
@@ -107,6 +107,4 @@
 		srcfname = arg[0]
 		tgtfname = arg[1]
-		tool = arg[2]
-		category = arg[3]
 		base = arg[4]
 		options = arg[5]
@@ -121,5 +119,5 @@
 		
 		# Only C files are interesting for us
-		if (tool != "cc"):
+		if (arg[2] != "cc"):
 			continue
 		
Index: uspace/app/bdsh/cmds/builtins/cd/cd.c
===================================================================
--- uspace/app/bdsh/cmds/builtins/cd/cd.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/bdsh/cmds/builtins/cd/cd.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -41,5 +41,5 @@
 #include "cd.h"
 
-static const char *cmdname = "cd";
+static char * cmdname = "cd";
 
 void help_cmd_cd(unsigned int level)
Index: uspace/app/bdsh/cmds/cmds.h
===================================================================
--- uspace/app/bdsh/cmds/cmds.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/bdsh/cmds/cmds.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -33,6 +33,6 @@
 /* Module structure */
 typedef struct {
-	const char *name;   /* Name of the command */
-	const char *desc;   /* Description of the command */
+	char *name;         /* Name of the command */
+	char *desc;         /* Description of the command */
 	mod_entry_t entry;  /* Command (exec) entry function */
 	mod_help_t help;    /* Command (help) entry function */
@@ -41,6 +41,6 @@
 /* Builtin structure, same as modules except different types of entry points */
 typedef struct {
-	const char *name;
-	const char *desc;
+	char *name;
+	char *desc;
 	builtin_entry_t entry;
 	builtin_help_t help;
@@ -57,5 +57,5 @@
 extern int is_module(const char *);
 extern int is_module_alias(const char *);
-extern char *alias_for_module(const char *);
+extern char * alias_for_module(const char *);
 extern int help_module(int, unsigned int);
 extern int run_module(int, char *[]);
@@ -65,5 +65,5 @@
 extern int is_builtin(const char *);
 extern int is_builtin_alias(const char *);
-extern char *alias_for_builtin(const char *);
+extern char * alias_for_builtin(const char *);
 extern int help_builtin(int, unsigned int);
 extern int run_builtin(int, char *[], cliuser_t *);
Index: uspace/app/bdsh/cmds/modules/cat/cat.c
===================================================================
--- uspace/app/bdsh/cmds/modules/cat/cat.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/bdsh/cmds/modules/cat/cat.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -43,9 +43,9 @@
 #include "cmds.h"
 
-static const char *cmdname = "cat";
+static char *cmdname = "cat";
 #define CAT_VERSION "0.0.1"
 #define CAT_DEFAULT_BUFLEN 1024
 
-static const char *cat_oops = "That option is not yet supported\n";
+static char *cat_oops = "That option is not yet supported\n";
 
 static struct option const long_options[] = {
Index: uspace/app/bdsh/cmds/modules/help/help.c
===================================================================
--- uspace/app/bdsh/cmds/modules/help/help.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/bdsh/cmds/modules/help/help.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -42,5 +42,5 @@
 #include "util.h"
 
-static const char *cmdname = "help";
+static char *cmdname = "help";
 extern const char *progname;
 
Index: uspace/app/bdsh/cmds/modules/kcon/kcon.c
===================================================================
--- uspace/app/bdsh/cmds/modules/kcon/kcon.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/bdsh/cmds/modules/kcon/kcon.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -40,5 +40,5 @@
 #include "cmds.h"
 
-static const char *cmdname = "kcon";
+static char *cmdname = "kcon";
 
 /* Dispays help for kcon in various levels */
Index: uspace/app/bdsh/cmds/modules/ls/ls.c
===================================================================
--- uspace/app/bdsh/cmds/modules/ls/ls.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/bdsh/cmds/modules/ls/ls.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -49,5 +49,5 @@
 #include "cmds.h"
 
-static const char *cmdname = "ls";
+static char *cmdname = "ls";
 
 static void ls_scan_dir(const char *d, DIR *dirp)
Index: uspace/app/bdsh/cmds/modules/mkdir/mkdir.c
===================================================================
--- uspace/app/bdsh/cmds/modules/mkdir/mkdir.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/bdsh/cmds/modules/mkdir/mkdir.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -49,5 +49,5 @@
 #define MKDIR_VERSION "0.0.1"
 
-static const char *cmdname = "mkdir";
+static char *cmdname = "mkdir";
 
 static struct option const long_options[] = {
Index: uspace/app/bdsh/cmds/modules/mkfile/mkfile.c
===================================================================
--- uspace/app/bdsh/cmds/modules/mkfile/mkfile.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/bdsh/cmds/modules/mkfile/mkfile.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -51,5 +51,5 @@
 #define BUFFER_SIZE 16384
 
-static const char *cmdname = "mkfile";
+static char *cmdname = "mkfile";
 
 static struct option const long_options[] = {
Index: uspace/app/bdsh/cmds/modules/module_aliases.h
===================================================================
--- uspace/app/bdsh/cmds/modules/module_aliases.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/bdsh/cmds/modules/module_aliases.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -12,5 +12,5 @@
  * the entry point being reached. */
 
-const char *mod_aliases[] = {
+char *mod_aliases[] = {
 	"ren", "mv",
 	"umount", "unmount",
Index: uspace/app/bdsh/cmds/modules/mount/mount.c
===================================================================
--- uspace/app/bdsh/cmds/modules/mount/mount.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/bdsh/cmds/modules/mount/mount.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -58,5 +58,5 @@
 {
 	unsigned int argc;
-	const char *mopts = "";
+	char *mopts = "";
 	int rc;
 
Index: uspace/app/bdsh/cmds/modules/pwd/pwd.c
===================================================================
--- uspace/app/bdsh/cmds/modules/pwd/pwd.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/bdsh/cmds/modules/pwd/pwd.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -39,5 +39,5 @@
 #include "pwd.h"
 
-static const char *cmdname = "pwd";
+static char * cmdname = "pwd";
 
 void help_cmd_pwd(unsigned int level)
Index: uspace/app/bdsh/cmds/modules/rm/rm.c
===================================================================
--- uspace/app/bdsh/cmds/modules/rm/rm.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ uspace/app/bdsh/cmds/modules/rm/rm.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -45,5 +45,5 @@
 #include "cmds.h"
 
-static const char *cmdname = "rm";
+static char *cmdname = "rm";
 #define RM_VERSION "0.0.1"
 
